searchNodes=[{"doc":"Schema-based In-Memory Graph Database. Usage Add Gim to your application by adding {:gim, &quot;~&gt; 1.2.0&quot;} to your list of dependencies in mix.exs: def deps do [ # ... {:gim, &quot;~&gt; 1.2.0&quot;} ] end Usage Create schemas: defmodule MyApp.Author do use Gim.Schema schema do property(:name, index: :unique) property(:age, default: 0, index: true) has_edges(:author_of, MyApp.Book, reflect: :authored_by) end end defmodule MyApp.Book do use Gim.Schema schema do property(:title, index: :unique) property(:body) has_edge(:authored_by, MyApp.Author, reflect: :author_of) end end defmodule MyApp.Publisher do use Gim.Schema alias MyApp.Book schema do property(:name, index: :unique) has_edges(:publisher_of, Book, reflect: :published_by) end end Create a repo: defmodule MyApp.Repo do use Gim.Repo, types: [ MyApp.Author, MyApp.Book, MyApp.Publisher ] end Use queries: iex&gt; MyApp.Repo.fetch!(MyApp.Author, :name, &quot;Terry Pratchett&quot;) %MyApp.Author{__id__: 2, __repo__: MyApp.Repo, age: 0, author_of: [4, 3], name: &quot;Terry Pratchett&quot;} iex&gt; terry = MyApp.Repo.fetch!(MyApp.Author, :name, &quot;Terry Pratchett&quot;) iex&gt; {:ok, [cs]} = MyApp.Publisher ...&gt; |&gt; Gim.Query.query() ...&gt; |&gt; Gim.Query.filter(name: &amp;String.starts_with?(&amp;1, &quot;Colin&quot;)) ...&gt; |&gt; MyApp.Repo.resolve() iex&gt; %MyApp.Book{title: &quot;The Colour of Magic&quot;} ...&gt; |&gt; Gim.Query.add_edge(:authored_by, terry) ...&gt; |&gt; Gim.Query.add_edge(:published_by, cs) ...&gt; |&gt; MyApp.Repo.insert!() %MyApp.Book{__id__: 5, __repo__: MyApp.Repo, authored_by: 2, body: nil, published_by: [3], title: &quot;The Colour of Magic&quot;}","ref":"Gim.html","title":"Gim","type":"module"},{"doc":"Internal helper module to handle indexes.","ref":"Gim.Index.html","title":"Gim.Index","type":"module"},{"doc":"Adds an id to the given index iex&gt; add([], 42) [42] iex&gt; add([404, 23, 13], 42) [404, 42, 23, 13] Since ids have to be unique, duplicates are prevented iex&gt; add([404, 42, 23, 13], 42) [404, 42, 23, 13]","ref":"Gim.Index.html#add/2","title":"Gim.Index.add/2","type":"function"},{"doc":"Returns the difference of two given indexes iex&gt; difference([99, 66, 77, 50, 30, 10, 0], [99, 70, 60, 50, 11, 10, 1, 0]) {[77, 66, 30], [70, 60, 11, 1]} iex&gt; difference([5, 4, 3, 2, 1], [5, 4, 3, 2, 1]) {[], []} iex&gt; difference([], []) {[], []}","ref":"Gim.Index.html#difference/2","title":"Gim.Index.difference/2","type":"function"},{"doc":"Intersects a list of indexes iex&gt; intersect([[99, 77, 66, 50, 30, 10, 0], [99, 70, 60, 50, 11, 10, 1, 0], [99, 50, 10]]) [99, 50, 10]","ref":"Gim.Index.html#intersect/1","title":"Gim.Index.intersect/1","type":"function"},{"doc":"Intersects the given indexes iex&gt; intersect([99, 66, 77, 50, 30, 10, 0], [99, 70, 60, 50, 11, 10, 1, 0]) [99, 50, 10, 0] iex&gt; intersect([], [99, 70, 60, 50, 11, 10, 1, 0]) []","ref":"Gim.Index.html#intersect/2","title":"Gim.Index.intersect/2","type":"function"},{"doc":"Intersects a list of indexes iex&gt; join([[99, 55, 42, 11], [98, 54, 42, 10], [90, 50, 42]]) [99, 98, 90, 55 , 54, 50, 42, 11, 10]","ref":"Gim.Index.html#join/1","title":"Gim.Index.join/1","type":"function"},{"doc":"Joins the given indexes iex&gt; join([99, 50, 13], [90, 50, 10]) [99, 90, 50, 13, 10] iex&gt; join([], [99, 70, 60, 50, 11, 10, 1, 0]) [99, 70, 60, 50, 11, 10, 1, 0]","ref":"Gim.Index.html#join/2","title":"Gim.Index.join/2","type":"function"},{"doc":"Turns a given list into an index iex&gt; new([10, 13, 6, 60, 2]) [60, 13, 10, 6, 2] iex&gt; new([2, 2, 2, 3]) [3, 2]","ref":"Gim.Index.html#new/1","title":"Gim.Index.new/1","type":"function"},{"doc":"Removes an id from the given index iex&gt; remove([], 42) [] iex&gt; remove([404, 42, 23, 13], 42) [404, 23, 13]","ref":"Gim.Index.html#remove/2","title":"Gim.Index.remove/2","type":"function"},{"doc":"","ref":"Gim.Index.html#t:id/0","title":"Gim.Index.id/0","type":"type"},{"doc":"","ref":"Gim.Index.html#t:index/0","title":"Gim.Index.index/0","type":"type"},{"doc":"Defines queries on schemas.","ref":"Gim.Query.html","title":"Gim.Query","type":"module"},{"doc":"","ref":"Gim.Query.html#add_edge/3","title":"Gim.Query.add_edge/3","type":"function"},{"doc":"","ref":"Gim.Query.html#clear_edge/2","title":"Gim.Query.clear_edge/2","type":"function"},{"doc":"","ref":"Gim.Query.html#clear_edges/1","title":"Gim.Query.clear_edges/1","type":"function"},{"doc":"","ref":"Gim.Query.html#delete_edge/3","title":"Gim.Query.delete_edge/3","type":"function"},{"doc":"Returns the target nodes following the edges of given label for the given node.","ref":"Gim.Query.html#edges/2","title":"Gim.Query.edges/2","type":"function"},{"doc":"","ref":"Gim.Query.html#expand/2","title":"Gim.Query.expand/2","type":"function"},{"doc":"Adds a new filter to the query.","ref":"Gim.Query.html#filter/3","title":"Gim.Query.filter/3","type":"function"},{"doc":"Returns wether the given node has any outgoing edges for the given label.","ref":"Gim.Query.html#has_edge?/2","title":"Gim.Query.has_edge?/2","type":"function"},{"doc":"Returns wether the given node has any outgoing edges.","ref":"Gim.Query.html#has_edges?/1","title":"Gim.Query.has_edges?/1","type":"function"},{"doc":"","ref":"Gim.Query.html#intersection/2","title":"Gim.Query.intersection/2","type":"function"},{"doc":"Computes all isolated nodes from a repo.","ref":"Gim.Query.html#isolated/1","title":"Gim.Query.isolated/1","type":"function"},{"doc":"","ref":"Gim.Query.html#query/1","title":"Gim.Query.query/1","type":"function"},{"doc":"","ref":"Gim.Query.html#query/2","title":"Gim.Query.query/2","type":"function"},{"doc":"","ref":"Gim.Query.html#reachable/3","title":"Gim.Query.reachable/3","type":"function"},{"doc":"Terse RDF Triple Language (Turtle) import and export for Gim.","ref":"Gim.Rdf.html","title":"Gim.Rdf","type":"module"},{"doc":"Read Terse RDF Triple Language (Turtle) format from a stream. pfun is an optional predicate mapping function.","ref":"Gim.Rdf.html#read_rdf/2","title":"Gim.Rdf.read_rdf/2","type":"function"},{"doc":"Stream raw Terse RDF Triple Language (Turtle) format from a stream. pfun is an optional predicate mapping function.","ref":"Gim.Rdf.html#stream_rdf/2","title":"Gim.Rdf.stream_rdf/2","type":"function"},{"doc":"","ref":"Gim.Rdf.html#write_rdf/1","title":"Gim.Rdf.write_rdf/1","type":"function"},{"doc":"Defines a repository. A repository maps to an underlying data store hold in-memory. When used, the repository expects the :types as option. The :types is a list of schema types to register. For example, the repository: defmodule Repo do use Gim.Repo, types: [Author, Post] end","ref":"Gim.Repo.html","title":"Gim.Repo","type":"module"},{"doc":"","ref":"Gim.Repo.Export.html","title":"Gim.Repo.Export","type":"module"},{"doc":"","ref":"Gim.Repo.Export.html#repo_meta_to_dot/1","title":"Gim.Repo.Export.repo_meta_to_dot/1","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_csv/1","title":"Gim.Repo.Export.repo_to_csv/1","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_csvfile/2","title":"Gim.Repo.Export.repo_to_csvfile/2","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_dot/2","title":"Gim.Repo.Export.repo_to_dot/2","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_dotfile/3","title":"Gim.Repo.Export.repo_to_dotfile/3","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_json/1","title":"Gim.Repo.Export.repo_to_json/1","type":"function"},{"doc":"","ref":"Gim.Repo.Export.html#repo_to_jsonfile/2","title":"Gim.Repo.Export.repo_to_jsonfile/2","type":"function"},{"doc":"Defines a typed table of nodes. A repository holds each distinct node type in a typed Table.","ref":"Gim.Repo.Table.html","title":"Gim.Repo.Table","type":"behaviour"},{"doc":"","ref":"Gim.Repo.Table.html#c:delete/2","title":"Gim.Repo.Table.delete/2","type":"callback"},{"doc":"","ref":"Gim.Repo.Table.html#c:insert/2","title":"Gim.Repo.Table.insert/2","type":"callback"},{"doc":"","ref":"Gim.Repo.Table.html#c:new/2","title":"Gim.Repo.Table.new/2","type":"callback"},{"doc":"","ref":"Gim.Repo.Table.html#c:query/3","title":"Gim.Repo.Table.query/3","type":"callback"},{"doc":"","ref":"Gim.Repo.Table.html#c:update/2","title":"Gim.Repo.Table.update/2","type":"callback"},{"doc":"","ref":"Gim.Repo.Table.Ets.html","title":"Gim.Repo.Table.Ets","type":"module"},{"doc":"Callback implementation for Gim.Repo.Table.delete/2.","ref":"Gim.Repo.Table.Ets.html#delete/2","title":"Gim.Repo.Table.Ets.delete/2","type":"function"},{"doc":"Callback implementation for Gim.Repo.Table.insert/2.","ref":"Gim.Repo.Table.Ets.html#insert/2","title":"Gim.Repo.Table.Ets.insert/2","type":"function"},{"doc":"Callback implementation for Gim.Repo.Table.new/2.","ref":"Gim.Repo.Table.Ets.html#new/2","title":"Gim.Repo.Table.Ets.new/2","type":"function"},{"doc":"Callback implementation for Gim.Repo.Table.query/3.","ref":"Gim.Repo.Table.Ets.html#query/3","title":"Gim.Repo.Table.Ets.query/3","type":"function"},{"doc":"Callback implementation for Gim.Repo.Table.update/2.","ref":"Gim.Repo.Table.Ets.html#update/2","title":"Gim.Repo.Table.Ets.update/2","type":"function"},{"doc":"Defines a schema. Example defmodule User do use Gim.Schema schema do property :name, index: :unique property :age, default: 0, index: true has_edges :author_of, Post, reflect: :authored_by end end Reflection Any schema module will generate the __schema__ function that can be used for runtime introspection of the schema: __schema__(:primary_key) - Returns the primary unique indexed property name or nil; __schema__(:properties) - Returns a list of all property names; __schema__(:indexes) - Returns a list of all indexed property names; __schema__(:index, property) - Returns how the given property is indexed; __schema__(:indexes_unique) - Returns a list of all unique indexed property names; __schema__(:indexes_non_unique) - Returns a list of all non-unique indexed property names; __schema__(:associations) - Returns a list of all association names; __schema__(:association, assoc) - Returns the association reflection of the given assoc; __schema__(:type, assoc) - Returns the type of the given association; Furthermore, __struct__ functions are defined so structs functionalities are available.","ref":"Gim.Schema.html","title":"Gim.Schema","type":"module"},{"doc":"Defines a named (i.e. implicitly labeled) edge to a given type on the schema. You can have zero or one edge with this name. Example schema do has_edge :authored_by, Person, reflect: :author_of end Options :reflect - Sets the edge name on the target type to automatically add a reflected edge on the target node.","ref":"Gim.Schema.html#has_edge/3","title":"Gim.Schema.has_edge/3","type":"macro"},{"doc":"Defines a named (i.e. implicitly labeled) edge to a given type on the schema. You can store multiple edges with this name. Example schema do has_edges :categories, Category, reflect: :publications end Options :reflect - Sets the edge name on the target type to automatically add a reflected edge on the target node.","ref":"Gim.Schema.html#has_edges/3","title":"Gim.Schema.has_edges/3","type":"macro"},{"doc":"Defines a property with given name on the node type schema. The property is not typed, you can store any valid term. Example schema do property :uuid, index: :primary property :fullname, index: :unique property :birthday, index: true property :hobbies end Options :default - Sets the default value on the schema and the struct. The default value is calculated at compilation time, so don&#39;t use expressions like DateTime.utc_now or Ecto.UUID.generate as they would then be the same for all nodes. :index - When true, the property is indexed for lookups. When :unique, the property uniquely indexed, which is enforced. When :primary, the property is uniquely indexed and used as primary key.","ref":"Gim.Schema.html#property/2","title":"Gim.Schema.property/2","type":"macro"},{"doc":"Defines a schema struct with a source name and property definitions.","ref":"Gim.Schema.html#schema/1","title":"Gim.Schema.schema/1","type":"macro"},{"doc":"Raised at runtime when a query is invalid.","ref":"Gim.DuplicateNodeError.html","title":"Gim.DuplicateNodeError","type":"exception"},{"doc":"Raised at runtime when a query is invalid.","ref":"Gim.MultipleNodesError.html","title":"Gim.MultipleNodesError","type":"exception"},{"doc":"Raised at runtime when a query tries to filter an unindexed property.","ref":"Gim.NoIndexError.html","title":"Gim.NoIndexError","type":"exception"},{"doc":"Raised at runtime when a query is invalid.","ref":"Gim.NoNodeError.html","title":"Gim.NoNodeError","type":"exception"},{"doc":"Raised at runtime when a query references an unknown type.","ref":"Gim.NoSuchTypeError.html","title":"Gim.NoSuchTypeError","type":"exception"},{"doc":"Raised at runtime when a query filter or expand is invalid.","ref":"Gim.QueryError.html","title":"Gim.QueryError","type":"exception"},{"doc":"Raised at compiletime when a schema is invalid.","ref":"Gim.SchemaError.html","title":"Gim.SchemaError","type":"exception"},{"doc":"Raised at runtime when a insert/update is invalid.","ref":"Gim.UnknownEdgeError.html","title":"Gim.UnknownEdgeError","type":"exception"}]